#include<bits/stdc++.h>
#define all(A) A.begin(), A.end()
using namespace std;

const int BLOCK = 450;

struct RSQ{
	int n;
	vector<int> data, cache;
	RSQ() {}
	RSQ(int n) {}
	void upd(int x){
		cache.push_back(x);
		if(cache.size() == BLOCK){
			for(auto x : cache) data.push_back(x);
			cache.clear();
			sort(data.begin(), data.end());
		}
	}
	int qry(int key){
		int ret = 0;
		for(auto x : cache){
			if(x <= key) ++ ret;
		}
		int low = 0, high = (int)data.size() - 1, ans = -1;
		while(low <= high){
			int mid = (low + high) / 2;
			if(data[mid] <= key){
				low = mid + 1;
				ans = mid;
			}
			else high = mid - 1;
		}
		ret += ans + 1;
		return ret;
	}
};

int main(){
	int n, m;
	cin >> m;
	vector<pair<int, int>> fishes(m);
	for(int i = 0; i < m; i ++) cin >> fishes[i].first;
	for(int i = 0; i < m; i ++) cin >> fishes[i].second;
	cin >> n;
	vector<pair<int, int>> fishermen(n);
	for(int i = 0; i < n; i ++) cin >> fishermen[i].first;
	for(int i = 0; i < n; i ++) cin >> fishermen[i].second;
	vector<int> ans(n, 0);
	{
		vector<array<int, 4>> events;
		for(auto [x, y] : fishes){
			events.push_back({x, 1, y - x, -1});
		}
		for(int i = 0; i < n; i ++){
			auto [x, l] = fishermen[i];
			events.push_back({x, 0, l - x,  i});
		}
		sort(events.begin(), events.end());
		RSQ ds;
		for(auto [x, type, key, idx] : events){
			if(type == 0) ans[idx] += ds.qry(key);
			if(type == 1) ds.upd(key);
		}
	}
	{
		vector<array<int, 4>> events;
		for(auto [x, y] : fishes){
			events.push_back({x, 1, y + x, -1});
		}
		for(int i = 0; i < n; i ++){
			auto [x, l] = fishermen[i];
			events.push_back({x, 0, l + x,  i});
		}
		sort(events.begin(), events.end(), greater<array<int, 4>>());
		RSQ ds;
		for(auto [x, type, key, idx] : events){
			if(type == 0) ans[idx] += ds.qry(key);
			if(type == 1) ds.upd(key);
		}
	}
	for(auto x : ans){
		cout << x << " ";
	} cout << endl;
}
